require 'rbconfig'
require 'find'
require "ftools"
require 'getopts'

CONFIG = Config::MAKEFILE_CONFIG

a=getopts(nil, 'prefix:')
if a>=2
  raise StandardError, "too many option"
end

prefix = CONFIG["prefix"]
libdir = prefix+"/lib/ruby/"+CONFIG["MAJOR"]+"."+CONFIG["MINOR"]
advanceddir = libdir+"/advanceddcl"
sitedir = CONFIG["sitedir"]+"/"+CONFIG["MAJOR"]+"."+CONFIG["MINOR"]
sitedir.gsub!(/\$\(prefix\)/, CONFIG["prefix"])
sitelibdir = sitedir+"/advanceddcl"

if $OPT_prefix
  libdir = $OPT_prefix+"/lib/ruby/"+CONFIG["MAJOR"]+"."+CONFIG["MINOR"]
  advanceddir = libdir+"/advanceddcl"
  sitedir = CONFIG["sitedir"]+"/"+CONFIG["MAJOR"]+"."+CONFIG["MINOR"]
  sitedir.gsub!(/\$\(prefix\)/, $OPT_prefix)
  sitelibdir = sitedir+"/advanceddcl"
end 

srcdir = File.dirname($0)
print "press key 1 or 2 (1:install, 2:site-install)\n"
install = gets.chomp.to_i

if(install == 1)
  Dir[File.join(srcdir || ".", "*.rb")].each{|file|
    if(/install.rb/ =~ file)
    elsif(/advanceddcl.rb/ =~ file)
      file = File.basename(file)
      File::makedirs(libdir)
      File::install(file, libdir+"/"+file, 0644, true)  
    else
      file = File.basename(file)
      File::makedirs(advanceddir)
      File::install(file, advanceddir+"/"+file, 0644, true)
  end
  }
elsif(install == 2)
  Dir[File.join(srcdir || ".", "*.rb")].each{|file|
    if(/install.rb/ =~ file)
    elsif(/advanceddcl.rb/ =~ file)
      file = File.basename(file)
      File::makedirs(sitedir)
      File::install(file, sitedir+"/"+file, 0644, true)
    else
      file = File.basename(file)
      File::makedirs(sitelibdir)
      File::install(file, sitelibdir+"/"+file, 0644, true)
  end
  }
else
  raise ArgumentError, "failed to install"
end
